# coding: utf-8

"""
DataCore API  - Sport

For more details, see openapi/init.py

The version of the OpenAPI document: v1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr, field_validator
from typing_extensions import Self


class FixtureParticipant(BaseModel):
    """
    FixtureParticipant
    """  # noqa: E501

    person_id: StrictStr = Field(description="The uuid of the person", alias="personId")
    entity_group_id: Optional[StrictStr] = Field(
        default=None, description="The uuid of the entity group", alias="entityGroupId"
    )
    is_home: Optional[StrictBool] = Field(default=None, description="Is participant the home person ?", alias="isHome")
    include_in_representation: Optional[StrictBool] = Field(
        default=None, description="Include participant in representation count", alias="includeInRepresentation"
    )
    draw: Optional[StrictBool] = Field(default=None, description="Result for this participant was a draw ?")
    result_status: Optional[StrictStr] = Field(default=None, description="Result status", alias="resultStatus")
    result_place: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Result placing (1=Won, 2=Lost)", alias="resultPlace"
    )
    result_secondary_score_place: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Secondary Score Result placing (1=Won, 2=Lost)", alias="resultSecondaryScorePlace"
    )
    starting_number: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Starting number", alias="startingNumber"
    )
    score: Optional[StrictStr] = Field(default=None, description="Score for participant in fixture")
    secondary_score: Optional[StrictStr] = Field(default=None, description="Secondary score", alias="secondaryScore")
    is_neutral_venue: Optional[StrictBool] = Field(
        default=None, description="Participant is playing at a neutral venue ?", alias="isNeutralVenue"
    )
    uniform_id: Optional[StrictStr] = Field(default=None, description="The uuid of the uniform", alias="uniformId")
    external_id: Optional[StrictStr] = Field(default=None, description="externalId", alias="externalId")
    __properties: ClassVar[List[str]] = [
        "personId",
        "entityGroupId",
        "isHome",
        "includeInRepresentation",
        "draw",
        "resultStatus",
        "resultPlace",
        "resultSecondaryScorePlace",
        "startingNumber",
        "score",
        "secondaryScore",
        "isNeutralVenue",
        "uniformId",
        "externalId",
    ]

    @field_validator("result_status")
    def result_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(
            [
                "SCHEDULED",
                "IN_PROGRESS",
                "CONFIRMED",
                "DISQUALIFIED",
                "FORFEITED",
                "WON_BY_FORFEIT",
                "DID_NOT_FINISH",
                "WITHDRAWN",
                "DID_NOT_START",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('SCHEDULED', 'IN_PROGRESS', 'CONFIRMED', 'DISQUALIFIED', 'FORFEITED', 'WON_BY_FORFEIT', 'DID_NOT_FINISH', 'WITHDRAWN', 'DID_NOT_START')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FixtureParticipant from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if result_place (nullable) is None
        # and model_fields_set contains the field
        if self.result_place is None and "result_place" in self.model_fields_set:
            _dict["resultPlace"] = None

        # set to None if result_secondary_score_place (nullable) is None
        # and model_fields_set contains the field
        if self.result_secondary_score_place is None and "result_secondary_score_place" in self.model_fields_set:
            _dict["resultSecondaryScorePlace"] = None

        # set to None if starting_number (nullable) is None
        # and model_fields_set contains the field
        if self.starting_number is None and "starting_number" in self.model_fields_set:
            _dict["startingNumber"] = None

        # set to None if score (nullable) is None
        # and model_fields_set contains the field
        if self.score is None and "score" in self.model_fields_set:
            _dict["score"] = None

        # set to None if secondary_score (nullable) is None
        # and model_fields_set contains the field
        if self.secondary_score is None and "secondary_score" in self.model_fields_set:
            _dict["secondaryScore"] = None

        # set to None if uniform_id (nullable) is None
        # and model_fields_set contains the field
        if self.uniform_id is None and "uniform_id" in self.model_fields_set:
            _dict["uniformId"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FixtureParticipant from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "personId": obj.get("personId"),
                "entityGroupId": obj.get("entityGroupId"),
                "isHome": obj.get("isHome"),
                "includeInRepresentation": obj.get("includeInRepresentation"),
                "draw": obj.get("draw"),
                "resultStatus": obj.get("resultStatus"),
                "resultPlace": obj.get("resultPlace"),
                "resultSecondaryScorePlace": obj.get("resultSecondaryScorePlace"),
                "startingNumber": obj.get("startingNumber"),
                "score": obj.get("score"),
                "secondaryScore": obj.get("secondaryScore"),
                "isNeutralVenue": obj.get("isNeutralVenue"),
                "uniformId": obj.get("uniformId"),
                "externalId": obj.get("externalId"),
            }
        )
        return _obj
