# coding: utf-8

"""
DataCore API  - Sport

For more details, see openapi/init.py

The version of the OpenAPI document: v1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing_extensions import Annotated, Self

from atriumsports.datacore.openapi.models.fixture_entities_model_entity import FixtureEntitiesModelEntity
from atriumsports.datacore.openapi.models.fixture_person_statistics_model_organization import (
    FixturePersonStatisticsModelOrganization,
)
from atriumsports.datacore.openapi.models.fixture_persons_model_person import FixturePersonsModelPerson
from atriumsports.datacore.openapi.models.fixture_progressions_model_fixture import FixtureProgressionsModelFixture


class FixturePersonStatisticsModel(BaseModel):
    """
    FixturePersonStatisticsModel
    """  # noqa: E501

    person_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the person", alias="personId"
    )
    person: Optional[FixturePersonsModelPerson] = None
    entity_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the entity", alias="entityId"
    )
    entity: Optional[FixtureEntitiesModelEntity] = None
    fixture_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the fixture", alias="fixtureId"
    )
    fixture: Optional[FixtureProgressionsModelFixture] = None
    organization_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the organization", alias="organizationId"
    )
    organization: Optional[FixturePersonStatisticsModelOrganization] = None
    statistics: Optional[Dict[str, Any]] = None
    bib: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="The number displayed on the jersey"
    )
    position: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="Playing position"
    )
    did_not_play_reason: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="The reason the player didn't play", alias="didNotPlayReason"
    )
    starter: Optional[StrictBool] = None
    participated: Optional[StrictBool] = Field(
        default=None, description="Did the person actually participate in the the fixture"
    )
    is_player: Optional[StrictBool] = Field(default=None, description="Is this person a player", alias="isPlayer")
    is_team_official: Optional[StrictBool] = Field(
        default=None, description="Is this person an entity official", alias="isTeamOfficial"
    )
    updated: Optional[datetime] = Field(default=None, description="Date/time last modified. In UTC")
    added: Optional[datetime] = Field(default=None, description="Date/time added. In UTC")
    __properties: ClassVar[List[str]] = [
        "personId",
        "person",
        "entityId",
        "entity",
        "fixtureId",
        "fixture",
        "organizationId",
        "organization",
        "statistics",
        "bib",
        "position",
        "didNotPlayReason",
        "starter",
        "participated",
        "isPlayer",
        "isTeamOfficial",
        "updated",
        "added",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FixturePersonStatisticsModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set(
            [
                "organization_id",
                "updated",
                "added",
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of person
        if self.person:
            _dict["person"] = self.person.to_dict()
        # override the default output from pydantic by calling `to_dict()` of entity
        if self.entity:
            _dict["entity"] = self.entity.to_dict()
        # override the default output from pydantic by calling `to_dict()` of fixture
        if self.fixture:
            _dict["fixture"] = self.fixture.to_dict()
        # override the default output from pydantic by calling `to_dict()` of organization
        if self.organization:
            _dict["organization"] = self.organization.to_dict()
        # set to None if entity_id (nullable) is None
        # and model_fields_set contains the field
        if self.entity_id is None and "entity_id" in self.model_fields_set:
            _dict["entityId"] = None

        # set to None if bib (nullable) is None
        # and model_fields_set contains the field
        if self.bib is None and "bib" in self.model_fields_set:
            _dict["bib"] = None

        # set to None if position (nullable) is None
        # and model_fields_set contains the field
        if self.position is None and "position" in self.model_fields_set:
            _dict["position"] = None

        # set to None if did_not_play_reason (nullable) is None
        # and model_fields_set contains the field
        if self.did_not_play_reason is None and "did_not_play_reason" in self.model_fields_set:
            _dict["didNotPlayReason"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FixturePersonStatisticsModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "personId": obj.get("personId"),
                "person": FixturePersonsModelPerson.from_dict(obj["person"]) if obj.get("person") is not None else None,
                "entityId": obj.get("entityId"),
                "entity": (
                    FixtureEntitiesModelEntity.from_dict(obj["entity"]) if obj.get("entity") is not None else None
                ),
                "fixtureId": obj.get("fixtureId"),
                "fixture": (
                    FixtureProgressionsModelFixture.from_dict(obj["fixture"])
                    if obj.get("fixture") is not None
                    else None
                ),
                "organizationId": obj.get("organizationId"),
                "organization": (
                    FixturePersonStatisticsModelOrganization.from_dict(obj["organization"])
                    if obj.get("organization") is not None
                    else None
                ),
                "statistics": obj.get("statistics"),
                "bib": obj.get("bib"),
                "position": obj.get("position"),
                "didNotPlayReason": obj.get("didNotPlayReason"),
                "starter": obj.get("starter"),
                "participated": obj.get("participated"),
                "isPlayer": obj.get("isPlayer"),
                "isTeamOfficial": obj.get("isTeamOfficial"),
                "updated": obj.get("updated"),
                "added": obj.get("added"),
            }
        )
        return _obj
