# coding: utf-8

"""
DataCore API  - Sport

For more details, see openapi/init.py

The version of the OpenAPI document: v1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing_extensions import Annotated, Self

from atriumsports.datacore.openapi.models.entities_model_entity_group import EntitiesModelEntityGroup
from atriumsports.datacore.openapi.models.fixture_entities_model_uniform import FixtureEntitiesModelUniform
from atriumsports.datacore.openapi.models.fixture_persons_model_organization import FixturePersonsModelOrganization
from atriumsports.datacore.openapi.models.fixture_persons_model_person import FixturePersonsModelPerson
from atriumsports.datacore.openapi.models.fixture_progressions_model_fixture import FixtureProgressionsModelFixture


class FixturePersonsModel(BaseModel):
    """
    FixturePersonsModel
    """  # noqa: E501

    fixture_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the fixture", alias="fixtureId"
    )
    fixture: Optional[FixtureProgressionsModelFixture] = None
    person_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the person", alias="personId"
    )
    person: Optional[FixturePersonsModelPerson] = None
    organization_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the organization", alias="organizationId"
    )
    organization: Optional[FixturePersonsModelOrganization] = None
    entity_group_id: Optional[StrictStr] = Field(
        default=None, description="The entity group that this entity belongs to", alias="entityGroupId"
    )
    entity_group: Optional[EntitiesModelEntityGroup] = Field(default=None, alias="entityGroup")
    is_home: Optional[StrictBool] = Field(default=None, description="Is competitor the home person ?", alias="isHome")
    draw: Optional[StrictBool] = Field(default=None, description="Result for this competitor was a draw ?")
    result_status: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None,
        description="Result status >- `CONFIRMED` Confirmed >- `DID_NOT_FINISH` Did Not Finish >- `DID_NOT_START` Did Not Start >- `DISQUALIFIED` Disqualified >- `FORFEITED` Forfeited >- `IN_PROGRESS` In Progress >- `SCHEDULED` Scheduled >- `WITHDRAWN` Withdrawn >- `WON_BY_FORFEIT` Won By Forfeit ",
        alias="resultStatus",
    )
    result_place: Optional[Annotated[int, Field(strict=True)]] = Field(
        default=None, description="Result placing (1=Won, 2=Lost)", alias="resultPlace"
    )
    result_secondary_score_place: Optional[Annotated[int, Field(strict=True)]] = Field(
        default=None, description="Result placing (1=Won, 2=Lost) of the Shoot Out", alias="resultSecondaryScorePlace"
    )
    starting_number: Optional[Annotated[int, Field(strict=True)]] = Field(
        default=None, description="Starting number", alias="startingNumber"
    )
    score: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="Score for competitor in fixture"
    )
    secondary_score: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="Secondary score", alias="secondaryScore"
    )
    is_neutral_venue: Optional[StrictBool] = Field(
        default=None, description="Competitor is playing at a neutral venue ?", alias="isNeutralVenue"
    )
    include_in_representation: Optional[StrictBool] = Field(
        default=True, description="Include this fixture in represented statistics?", alias="includeInRepresentation"
    )
    uniform_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the uniform", alias="uniformId"
    )
    uniform: Optional[FixtureEntitiesModelUniform] = None
    external_id: Optional[Annotated[str, Field(strict=True, max_length=150)]] = Field(
        default=None, description="The Id of the data as set by the provider of the data", alias="externalId"
    )
    updated: Optional[datetime] = Field(default=None, description="Date/time last modified. In UTC")
    added: Optional[datetime] = Field(default=None, description="Date/time added. In UTC")
    __properties: ClassVar[List[str]] = [
        "fixtureId",
        "fixture",
        "personId",
        "person",
        "organizationId",
        "organization",
        "entityGroupId",
        "entityGroup",
        "isHome",
        "draw",
        "resultStatus",
        "resultPlace",
        "resultSecondaryScorePlace",
        "startingNumber",
        "score",
        "secondaryScore",
        "isNeutralVenue",
        "includeInRepresentation",
        "uniformId",
        "uniform",
        "externalId",
        "updated",
        "added",
    ]

    @field_validator("result_status")
    def result_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(
            [
                "SCHEDULED",
                "IN_PROGRESS",
                "CONFIRMED",
                "DISQUALIFIED",
                "FORFEITED",
                "WON_BY_FORFEIT",
                "DID_NOT_FINISH",
                "WITHDRAWN",
                "DID_NOT_START",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('SCHEDULED', 'IN_PROGRESS', 'CONFIRMED', 'DISQUALIFIED', 'FORFEITED', 'WON_BY_FORFEIT', 'DID_NOT_FINISH', 'WITHDRAWN', 'DID_NOT_START')"
            )
        return value

    @field_validator("external_id")
    def external_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[0-9A-Za-z\/_-]+$", value):
            raise ValueError(r"must validate the regular expression /^[0-9A-Za-z\/_-]+$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FixturePersonsModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set(
            [
                "organization_id",
                "updated",
                "added",
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of fixture
        if self.fixture:
            _dict["fixture"] = self.fixture.to_dict()
        # override the default output from pydantic by calling `to_dict()` of person
        if self.person:
            _dict["person"] = self.person.to_dict()
        # override the default output from pydantic by calling `to_dict()` of organization
        if self.organization:
            _dict["organization"] = self.organization.to_dict()
        # override the default output from pydantic by calling `to_dict()` of entity_group
        if self.entity_group:
            _dict["entityGroup"] = self.entity_group.to_dict()
        # override the default output from pydantic by calling `to_dict()` of uniform
        if self.uniform:
            _dict["uniform"] = self.uniform.to_dict()
        # set to None if entity_group_id (nullable) is None
        # and model_fields_set contains the field
        if self.entity_group_id is None and "entity_group_id" in self.model_fields_set:
            _dict["entityGroupId"] = None

        # set to None if result_place (nullable) is None
        # and model_fields_set contains the field
        if self.result_place is None and "result_place" in self.model_fields_set:
            _dict["resultPlace"] = None

        # set to None if result_secondary_score_place (nullable) is None
        # and model_fields_set contains the field
        if self.result_secondary_score_place is None and "result_secondary_score_place" in self.model_fields_set:
            _dict["resultSecondaryScorePlace"] = None

        # set to None if starting_number (nullable) is None
        # and model_fields_set contains the field
        if self.starting_number is None and "starting_number" in self.model_fields_set:
            _dict["startingNumber"] = None

        # set to None if score (nullable) is None
        # and model_fields_set contains the field
        if self.score is None and "score" in self.model_fields_set:
            _dict["score"] = None

        # set to None if secondary_score (nullable) is None
        # and model_fields_set contains the field
        if self.secondary_score is None and "secondary_score" in self.model_fields_set:
            _dict["secondaryScore"] = None

        # set to None if uniform_id (nullable) is None
        # and model_fields_set contains the field
        if self.uniform_id is None and "uniform_id" in self.model_fields_set:
            _dict["uniformId"] = None

        # set to None if external_id (nullable) is None
        # and model_fields_set contains the field
        if self.external_id is None and "external_id" in self.model_fields_set:
            _dict["externalId"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FixturePersonsModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "fixtureId": obj.get("fixtureId"),
                "fixture": (
                    FixtureProgressionsModelFixture.from_dict(obj["fixture"])
                    if obj.get("fixture") is not None
                    else None
                ),
                "personId": obj.get("personId"),
                "person": FixturePersonsModelPerson.from_dict(obj["person"]) if obj.get("person") is not None else None,
                "organizationId": obj.get("organizationId"),
                "organization": (
                    FixturePersonsModelOrganization.from_dict(obj["organization"])
                    if obj.get("organization") is not None
                    else None
                ),
                "entityGroupId": obj.get("entityGroupId"),
                "entityGroup": (
                    EntitiesModelEntityGroup.from_dict(obj["entityGroup"])
                    if obj.get("entityGroup") is not None
                    else None
                ),
                "isHome": obj.get("isHome"),
                "draw": obj.get("draw"),
                "resultStatus": obj.get("resultStatus"),
                "resultPlace": obj.get("resultPlace"),
                "resultSecondaryScorePlace": obj.get("resultSecondaryScorePlace"),
                "startingNumber": obj.get("startingNumber"),
                "score": obj.get("score"),
                "secondaryScore": obj.get("secondaryScore"),
                "isNeutralVenue": obj.get("isNeutralVenue"),
                "includeInRepresentation": (
                    obj.get("includeInRepresentation") if obj.get("includeInRepresentation") is not None else True
                ),
                "uniformId": obj.get("uniformId"),
                "uniform": (
                    FixtureEntitiesModelUniform.from_dict(obj["uniform"]) if obj.get("uniform") is not None else None
                ),
                "externalId": obj.get("externalId"),
                "updated": obj.get("updated"),
                "added": obj.get("added"),
            }
        )
        return _obj
