# coding: utf-8

"""
DataCore API  - Sport

For more details, see openapi/init.py

The version of the OpenAPI document: v1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing_extensions import Self

from atriumsports.datacore.openapi.models.leader_qualifiers_model_organization import LeaderQualifiersModelOrganization
from atriumsports.datacore.openapi.models.seasons_model_leaders_criteria import SeasonsModelLeadersCriteria


class LeaderQualifiersModel(BaseModel):
    """
    LeaderQualifiersModel
    """  # noqa: E501

    updated: Optional[datetime] = Field(default=None, description="Date/time last modified. In UTC")
    added: Optional[datetime] = Field(default=None, description="Date/time added. In UTC")
    qualifier_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the leader qualifier", alias="qualifierId"
    )
    organization_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the organization", alias="organizationId"
    )
    organization: Optional[LeaderQualifiersModelOrganization] = None
    leader_criteria_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the ~LeaderCriteria~", alias="leaderCriteriaId"
    )
    leaders_criteria: Optional[SeasonsModelLeadersCriteria] = Field(default=None, alias="leadersCriteria")
    statistic_field: Optional[StrictStr] = Field(
        default=None, description="The statistic field that this qualifier is for.", alias="statisticField"
    )
    comparison_field: Optional[StrictStr] = Field(
        default=None, description="The statistic field to compare against.", alias="comparisonField"
    )
    comparison_type: Optional[StrictStr] = Field(
        default=None,
        description="Comparison type for the qualifier >- `EQUAL` Equal >- `GREATER_THAN` Greater than >- `GREATER_THAN_EQUAL` Greater than or equal >- `LESS_THAN` Less than >- `LESS_THAN_EQUAL` Less than or equal ",
        alias="comparisonType",
    )
    comparison_value: Optional[Union[StrictFloat, StrictInt]] = Field(
        default=None, description="Comparison value for the qualifier", alias="comparisonValue"
    )
    __properties: ClassVar[List[str]] = [
        "updated",
        "added",
        "qualifierId",
        "organizationId",
        "organization",
        "leaderCriteriaId",
        "leadersCriteria",
        "statisticField",
        "comparisonField",
        "comparisonType",
        "comparisonValue",
    ]

    @field_validator("comparison_type")
    def comparison_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["GREATER_THAN", "LESS_THAN", "EQUAL", "GREATER_THAN_EQUAL", "LESS_THAN_EQUAL"]):
            raise ValueError(
                "must be one of enum values ('GREATER_THAN', 'LESS_THAN', 'EQUAL', 'GREATER_THAN_EQUAL', 'LESS_THAN_EQUAL')"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LeaderQualifiersModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set(
            [
                "updated",
                "added",
                "organization_id",
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of organization
        if self.organization:
            _dict["organization"] = self.organization.to_dict()
        # override the default output from pydantic by calling `to_dict()` of leaders_criteria
        if self.leaders_criteria:
            _dict["leadersCriteria"] = self.leaders_criteria.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LeaderQualifiersModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "updated": obj.get("updated"),
                "added": obj.get("added"),
                "qualifierId": obj.get("qualifierId"),
                "organizationId": obj.get("organizationId"),
                "organization": (
                    LeaderQualifiersModelOrganization.from_dict(obj["organization"])
                    if obj.get("organization") is not None
                    else None
                ),
                "leaderCriteriaId": obj.get("leaderCriteriaId"),
                "leadersCriteria": (
                    SeasonsModelLeadersCriteria.from_dict(obj["leadersCriteria"])
                    if obj.get("leadersCriteria") is not None
                    else None
                ),
                "statisticField": obj.get("statisticField"),
                "comparisonField": obj.get("comparisonField"),
                "comparisonType": obj.get("comparisonType"),
                "comparisonValue": obj.get("comparisonValue"),
            }
        )
        return _obj
