# coding: utf-8

"""
DataCore API  - Sport

For more details, see openapi/init.py

The version of the OpenAPI document: v1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import date
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing_extensions import Annotated, Self

from atriumsports.datacore.openapi.models.person_additional_details import PersonAdditionalDetails
from atriumsports.datacore.openapi.models.person_historical_name import PersonHistoricalName
from atriumsports.datacore.openapi.models.person_post_body_additional_names_value import (
    PersonPostBodyAdditionalNamesValue,
)
from atriumsports.datacore.openapi.models.social_media import SocialMedia


class PersonPutBody(BaseModel):
    """
    PersonPutBody
    """  # noqa: E501

    status: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default="ACTIVE",
        description="Status >- `ACTIVE` Active >- `DECEASED` Deceased >- `INACTIVE` Inactive >- `PENDING` Pending >- `UNREGISTERED` UnRegistered ",
    )
    gender: Optional[StrictStr] = Field(
        default=None, description="The gender of the person >- `FEMALE` Female >- `MALE` Male >- `UNKNOWN` Unknown "
    )
    name_full_local: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(
        default=None,
        description="The full name of the person in [local](#section/Introduction/Character-Sets-and-Names) language",
        alias="nameFullLocal",
    )
    name_abbreviated: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="An abbreviated name for a person", alias="nameAbbreviated"
    )
    language_local: Optional[Annotated[str, Field(strict=True, max_length=2)]] = Field(
        default=None,
        description="The language code of the full name in [local](#section/Introduction/Character-Sets-and-Names) language. This code is a two letter (lower-case) ISO 639-1 language code.",
        alias="languageLocal",
    )
    name_given_local: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(
        default=None,
        description="Given name of the person in [local](#section/Introduction/Character-Sets-and-Names) language",
        alias="nameGivenLocal",
    )
    name_family_local: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(
        default=None,
        description="Family name of the person in [local](#section/Introduction/Character-Sets-and-Names) language",
        alias="nameFamilyLocal",
    )
    name_full_latin: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(
        default=None,
        description="The full name of the person in [latin](##section/Introduction/Character-Sets-and-Names) characters",
        alias="nameFullLatin",
    )
    name_given_latin: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(
        default=None,
        description="Given name of the person in [latin](#section/Introduction/Character-Sets-and-Names) characters",
        alias="nameGivenLatin",
    )
    name_family_latin: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(
        default=None,
        description="Family name of the person in [latin](#section/Introduction/Character-Sets-and-Names) characters",
        alias="nameFamilyLatin",
    )
    dob: Optional[date] = Field(default=None, description="Date of Birth")
    nationality: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(
        default=None, description="A 3 letter nationality code. We recommend you use ISO-3166 where available."
    )
    deceased: Optional[date] = Field(default=None, description="Date deceased")
    additional_names: Optional[Dict[str, PersonPostBodyAdditionalNamesValue]] = Field(
        default=None,
        description="Additional names for the person. They are broken down by language, so you can have a different set of names per language",
        alias="additionalNames",
    )
    additional_details: Optional[PersonAdditionalDetails] = Field(default=None, alias="additionalDetails")
    social: Optional[SocialMedia] = None
    historical_names: Optional[List[PersonHistoricalName]] = Field(
        default=None, description="Array of person historical names", alias="historicalNames"
    )
    representing: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="Who the person or entity was representing"
    )
    external_id: Optional[Annotated[str, Field(strict=True, max_length=150)]] = Field(
        default=None, description="The Id of the data as set by the provider of the data", alias="externalId"
    )
    __properties: ClassVar[List[str]] = [
        "status",
        "gender",
        "nameFullLocal",
        "nameAbbreviated",
        "languageLocal",
        "nameGivenLocal",
        "nameFamilyLocal",
        "nameFullLatin",
        "nameGivenLatin",
        "nameFamilyLatin",
        "dob",
        "nationality",
        "deceased",
        "additionalNames",
        "additionalDetails",
        "social",
        "historicalNames",
        "representing",
        "externalId",
    ]

    @field_validator("status")
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["ACTIVE", "UNREGISTERED", "PENDING", "DECEASED", "INACTIVE"]):
            raise ValueError("must be one of enum values ('ACTIVE', 'UNREGISTERED', 'PENDING', 'DECEASED', 'INACTIVE')")
        return value

    @field_validator("gender")
    def gender_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["MALE", "FEMALE", "UNKNOWN"]):
            raise ValueError("must be one of enum values ('MALE', 'FEMALE', 'UNKNOWN')")
        return value

    @field_validator("external_id")
    def external_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[0-9A-Za-z\/_-]+$", value):
            raise ValueError(r"must validate the regular expression /^[0-9A-Za-z\/_-]+$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PersonPutBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in additional_names (dict)
        _field_dict = {}
        if self.additional_names:
            for _key_additional_names in self.additional_names:
                if self.additional_names[_key_additional_names]:
                    _field_dict[_key_additional_names] = self.additional_names[_key_additional_names].to_dict()
            _dict["additionalNames"] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of additional_details
        if self.additional_details:
            _dict["additionalDetails"] = self.additional_details.to_dict()
        # override the default output from pydantic by calling `to_dict()` of social
        if self.social:
            _dict["social"] = self.social.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in historical_names (list)
        _items = []
        if self.historical_names:
            for _item_historical_names in self.historical_names:
                if _item_historical_names:
                    _items.append(_item_historical_names.to_dict())
            _dict["historicalNames"] = _items
        # set to None if name_abbreviated (nullable) is None
        # and model_fields_set contains the field
        if self.name_abbreviated is None and "name_abbreviated" in self.model_fields_set:
            _dict["nameAbbreviated"] = None

        # set to None if language_local (nullable) is None
        # and model_fields_set contains the field
        if self.language_local is None and "language_local" in self.model_fields_set:
            _dict["languageLocal"] = None

        # set to None if name_given_local (nullable) is None
        # and model_fields_set contains the field
        if self.name_given_local is None and "name_given_local" in self.model_fields_set:
            _dict["nameGivenLocal"] = None

        # set to None if name_family_local (nullable) is None
        # and model_fields_set contains the field
        if self.name_family_local is None and "name_family_local" in self.model_fields_set:
            _dict["nameFamilyLocal"] = None

        # set to None if name_full_latin (nullable) is None
        # and model_fields_set contains the field
        if self.name_full_latin is None and "name_full_latin" in self.model_fields_set:
            _dict["nameFullLatin"] = None

        # set to None if name_given_latin (nullable) is None
        # and model_fields_set contains the field
        if self.name_given_latin is None and "name_given_latin" in self.model_fields_set:
            _dict["nameGivenLatin"] = None

        # set to None if name_family_latin (nullable) is None
        # and model_fields_set contains the field
        if self.name_family_latin is None and "name_family_latin" in self.model_fields_set:
            _dict["nameFamilyLatin"] = None

        # set to None if dob (nullable) is None
        # and model_fields_set contains the field
        if self.dob is None and "dob" in self.model_fields_set:
            _dict["dob"] = None

        # set to None if nationality (nullable) is None
        # and model_fields_set contains the field
        if self.nationality is None and "nationality" in self.model_fields_set:
            _dict["nationality"] = None

        # set to None if deceased (nullable) is None
        # and model_fields_set contains the field
        if self.deceased is None and "deceased" in self.model_fields_set:
            _dict["deceased"] = None

        # set to None if additional_names (nullable) is None
        # and model_fields_set contains the field
        if self.additional_names is None and "additional_names" in self.model_fields_set:
            _dict["additionalNames"] = None

        # set to None if additional_details (nullable) is None
        # and model_fields_set contains the field
        if self.additional_details is None and "additional_details" in self.model_fields_set:
            _dict["additionalDetails"] = None

        # set to None if social (nullable) is None
        # and model_fields_set contains the field
        if self.social is None and "social" in self.model_fields_set:
            _dict["social"] = None

        # set to None if historical_names (nullable) is None
        # and model_fields_set contains the field
        if self.historical_names is None and "historical_names" in self.model_fields_set:
            _dict["historicalNames"] = None

        # set to None if representing (nullable) is None
        # and model_fields_set contains the field
        if self.representing is None and "representing" in self.model_fields_set:
            _dict["representing"] = None

        # set to None if external_id (nullable) is None
        # and model_fields_set contains the field
        if self.external_id is None and "external_id" in self.model_fields_set:
            _dict["externalId"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PersonPutBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "status": obj.get("status") if obj.get("status") is not None else "ACTIVE",
                "gender": obj.get("gender"),
                "nameFullLocal": obj.get("nameFullLocal"),
                "nameAbbreviated": obj.get("nameAbbreviated"),
                "languageLocal": obj.get("languageLocal"),
                "nameGivenLocal": obj.get("nameGivenLocal"),
                "nameFamilyLocal": obj.get("nameFamilyLocal"),
                "nameFullLatin": obj.get("nameFullLatin"),
                "nameGivenLatin": obj.get("nameGivenLatin"),
                "nameFamilyLatin": obj.get("nameFamilyLatin"),
                "dob": obj.get("dob"),
                "nationality": obj.get("nationality"),
                "deceased": obj.get("deceased"),
                "additionalNames": (
                    dict(
                        (_k, PersonPostBodyAdditionalNamesValue.from_dict(_v))
                        for _k, _v in obj["additionalNames"].items()
                    )
                    if obj.get("additionalNames") is not None
                    else None
                ),
                "additionalDetails": (
                    PersonAdditionalDetails.from_dict(obj["additionalDetails"])
                    if obj.get("additionalDetails") is not None
                    else None
                ),
                "social": SocialMedia.from_dict(obj["social"]) if obj.get("social") is not None else None,
                "historicalNames": (
                    [PersonHistoricalName.from_dict(_item) for _item in obj["historicalNames"]]
                    if obj.get("historicalNames") is not None
                    else None
                ),
                "representing": obj.get("representing"),
                "externalId": obj.get("externalId"),
            }
        )
        return _obj
