# coding: utf-8

"""
DataCore API  - Sport

For more details, see openapi/init.py

The version of the OpenAPI document: v1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing_extensions import Self


class SeasonPostBodyPromotionRelegationRulesInner(BaseModel):
    """
    SeasonPostBodyPromotionRelegationRulesInner
    """  # noqa: E501

    rule_type: StrictStr = Field(description="Rule Type", alias="ruleType")
    position: Union[StrictFloat, StrictInt] = Field(description="Standings Position")
    value: StrictStr = Field(description="Value to apply to Promotion or Relegation")
    __properties: ClassVar[List[str]] = ["ruleType", "position", "value"]

    @field_validator("rule_type")
    def rule_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(["PROMOTION", "RELEGATION"]):
            raise ValueError("must be one of enum values ('PROMOTION', 'RELEGATION')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SeasonPostBodyPromotionRelegationRulesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SeasonPostBodyPromotionRelegationRulesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {"ruleType": obj.get("ruleType"), "position": obj.get("position"), "value": obj.get("value")}
        )
        return _obj
