# coding: utf-8

"""
DataCore API  - Sport

For more details, see openapi/init.py

The version of the OpenAPI document: v1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import date, datetime
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing_extensions import Annotated, Self

from atriumsports.datacore.openapi.models.fixture_entities_model_conference import FixtureEntitiesModelConference
from atriumsports.datacore.openapi.models.fixture_entities_model_division import FixtureEntitiesModelDivision
from atriumsports.datacore.openapi.models.fixture_progressions_model_season import FixtureProgressionsModelSeason
from atriumsports.datacore.openapi.models.season_fixture_stages_pools_list_model_pool import (
    SeasonFixtureStagesPoolsListModelPool,
)
from atriumsports.datacore.openapi.models.season_fixture_stages_pools_list_model_stage import (
    SeasonFixtureStagesPoolsListModelStage,
)
from atriumsports.datacore.openapi.models.season_series_competitor import SeasonSeriesCompetitor
from atriumsports.datacore.openapi.models.season_series_model_organization import SeasonSeriesModelOrganization


class SeasonSeriesModel(BaseModel):
    """
    SeasonSeriesModel
    """  # noqa: E501

    series_code: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None, description="A unique code for the season series. (Unique for season)", alias="seriesCode"
    )
    season_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the season", alias="seasonId"
    )
    season: Optional[FixtureProgressionsModelSeason] = None
    organization_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the organization", alias="organizationId"
    )
    organization: Optional[SeasonSeriesModelOrganization] = None
    conference_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the conference", alias="conferenceId"
    )
    conference: Optional[FixtureEntitiesModelConference] = None
    division_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the division", alias="divisionId"
    )
    division: Optional[FixtureEntitiesModelDivision] = None
    name_local: Optional[Annotated[str, Field(strict=True, max_length=150)]] = Field(
        default=None,
        description="The name of the series in the [local](#section/Introduction/Character-Sets-and-Names) language",
        alias="nameLocal",
    )
    abbreviation_local: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(
        default=None,
        description="An abbreviation/short name in the [local](#section/Introduction/Character-Sets-and-Names) language",
        alias="abbreviationLocal",
    )
    name_latin: Optional[Annotated[str, Field(strict=True, max_length=150)]] = Field(
        default=None,
        description="The name of the series in [latin](#section/Introduction/Character-Sets-and-Names) characters",
        alias="nameLatin",
    )
    abbreviation_latin: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(
        default=None,
        description="An abbreviation/short name in [latin](#section/Introduction/Character-Sets-and-Names) characters",
        alias="abbreviationLatin",
    )
    status: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None, description="Status >- `ACTIVE` Active >- `COMPLETE` Complete >- `NOT_STARTED` Not Started "
    )
    series_type: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(
        default=None,
        description="The type of series >- `BEST_OF` Best of >- `HOME_AND_AWAY` Home and Away >- `KNOCKOUT` Knockout ",
        alias="seriesType",
    )
    auto_calculated: Optional[StrictBool] = Field(
        default=None, description="Is the winner auto calculated?", alias="autoCalculated"
    )
    best_of: Optional[Annotated[int, Field(strict=True)]] = Field(
        default=None, description="Best of number", alias="bestOf"
    )
    series_number: Optional[Annotated[int, Field(strict=True)]] = Field(
        default=None, description="User defined series number", alias="seriesNumber"
    )
    max_fixtures_number: Optional[StrictInt] = Field(
        default=None, description="The maximum number of games within a playoff series", alias="maxFixturesNumber"
    )
    winner: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the winner, person or entity"
    )
    series_order: Optional[Annotated[int, Field(strict=True)]] = Field(
        default=None, description="User defined sort order of the series", alias="seriesOrder"
    )
    stage_code: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None, description="A unique code for the stage. (Unique for season)", alias="stageCode"
    )
    stage: Optional[SeasonFixtureStagesPoolsListModelStage] = None
    pool_code: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None, description="A unique code for the pool. (Unique for season)", alias="poolCode"
    )
    pool: Optional[SeasonFixtureStagesPoolsListModelPool] = None
    start_date: Optional[date] = Field(default=None, description="Series start date", alias="startDate")
    end_date: Optional[date] = Field(default=None, description="Series end date", alias="endDate")
    external_id: Optional[Annotated[str, Field(strict=True, max_length=150)]] = Field(
        default=None, description="The Id of the data as set by the provider of the data", alias="externalId"
    )
    updated: Optional[datetime] = Field(default=None, description="Date/time last modified. In UTC")
    added: Optional[datetime] = Field(default=None, description="Date/time added. In UTC")
    competitors: Optional[List[SeasonSeriesCompetitor]] = Field(
        default=None, description="Array of competitors in the series. A competitor may have a results and a ranking"
    )
    __properties: ClassVar[List[str]] = [
        "seriesCode",
        "seasonId",
        "season",
        "organizationId",
        "organization",
        "conferenceId",
        "conference",
        "divisionId",
        "division",
        "nameLocal",
        "abbreviationLocal",
        "nameLatin",
        "abbreviationLatin",
        "status",
        "seriesType",
        "autoCalculated",
        "bestOf",
        "seriesNumber",
        "maxFixturesNumber",
        "winner",
        "seriesOrder",
        "stageCode",
        "stage",
        "poolCode",
        "pool",
        "startDate",
        "endDate",
        "externalId",
        "updated",
        "added",
        "competitors",
    ]

    @field_validator("status")
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["NOT_STARTED", "ACTIVE", "COMPLETE"]):
            raise ValueError("must be one of enum values ('NOT_STARTED', 'ACTIVE', 'COMPLETE')")
        return value

    @field_validator("series_type")
    def series_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["BEST_OF", "HOME_AND_AWAY", "KNOCKOUT"]):
            raise ValueError("must be one of enum values ('BEST_OF', 'HOME_AND_AWAY', 'KNOCKOUT')")
        return value

    @field_validator("external_id")
    def external_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[0-9A-Za-z\/_-]+$", value):
            raise ValueError(r"must validate the regular expression /^[0-9A-Za-z\/_-]+$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SeasonSeriesModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set(
            [
                "organization_id",
                "updated",
                "added",
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of season
        if self.season:
            _dict["season"] = self.season.to_dict()
        # override the default output from pydantic by calling `to_dict()` of organization
        if self.organization:
            _dict["organization"] = self.organization.to_dict()
        # override the default output from pydantic by calling `to_dict()` of conference
        if self.conference:
            _dict["conference"] = self.conference.to_dict()
        # override the default output from pydantic by calling `to_dict()` of division
        if self.division:
            _dict["division"] = self.division.to_dict()
        # override the default output from pydantic by calling `to_dict()` of stage
        if self.stage:
            _dict["stage"] = self.stage.to_dict()
        # override the default output from pydantic by calling `to_dict()` of pool
        if self.pool:
            _dict["pool"] = self.pool.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in competitors (list)
        _items = []
        if self.competitors:
            for _item_competitors in self.competitors:
                if _item_competitors:
                    _items.append(_item_competitors.to_dict())
            _dict["competitors"] = _items
        # set to None if conference_id (nullable) is None
        # and model_fields_set contains the field
        if self.conference_id is None and "conference_id" in self.model_fields_set:
            _dict["conferenceId"] = None

        # set to None if division_id (nullable) is None
        # and model_fields_set contains the field
        if self.division_id is None and "division_id" in self.model_fields_set:
            _dict["divisionId"] = None

        # set to None if abbreviation_local (nullable) is None
        # and model_fields_set contains the field
        if self.abbreviation_local is None and "abbreviation_local" in self.model_fields_set:
            _dict["abbreviationLocal"] = None

        # set to None if name_latin (nullable) is None
        # and model_fields_set contains the field
        if self.name_latin is None and "name_latin" in self.model_fields_set:
            _dict["nameLatin"] = None

        # set to None if abbreviation_latin (nullable) is None
        # and model_fields_set contains the field
        if self.abbreviation_latin is None and "abbreviation_latin" in self.model_fields_set:
            _dict["abbreviationLatin"] = None

        # set to None if best_of (nullable) is None
        # and model_fields_set contains the field
        if self.best_of is None and "best_of" in self.model_fields_set:
            _dict["bestOf"] = None

        # set to None if series_number (nullable) is None
        # and model_fields_set contains the field
        if self.series_number is None and "series_number" in self.model_fields_set:
            _dict["seriesNumber"] = None

        # set to None if max_fixtures_number (nullable) is None
        # and model_fields_set contains the field
        if self.max_fixtures_number is None and "max_fixtures_number" in self.model_fields_set:
            _dict["maxFixturesNumber"] = None

        # set to None if winner (nullable) is None
        # and model_fields_set contains the field
        if self.winner is None and "winner" in self.model_fields_set:
            _dict["winner"] = None

        # set to None if series_order (nullable) is None
        # and model_fields_set contains the field
        if self.series_order is None and "series_order" in self.model_fields_set:
            _dict["seriesOrder"] = None

        # set to None if stage_code (nullable) is None
        # and model_fields_set contains the field
        if self.stage_code is None and "stage_code" in self.model_fields_set:
            _dict["stageCode"] = None

        # set to None if pool_code (nullable) is None
        # and model_fields_set contains the field
        if self.pool_code is None and "pool_code" in self.model_fields_set:
            _dict["poolCode"] = None

        # set to None if start_date (nullable) is None
        # and model_fields_set contains the field
        if self.start_date is None and "start_date" in self.model_fields_set:
            _dict["startDate"] = None

        # set to None if end_date (nullable) is None
        # and model_fields_set contains the field
        if self.end_date is None and "end_date" in self.model_fields_set:
            _dict["endDate"] = None

        # set to None if external_id (nullable) is None
        # and model_fields_set contains the field
        if self.external_id is None and "external_id" in self.model_fields_set:
            _dict["externalId"] = None

        # set to None if competitors (nullable) is None
        # and model_fields_set contains the field
        if self.competitors is None and "competitors" in self.model_fields_set:
            _dict["competitors"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SeasonSeriesModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "seriesCode": obj.get("seriesCode"),
                "seasonId": obj.get("seasonId"),
                "season": (
                    FixtureProgressionsModelSeason.from_dict(obj["season"]) if obj.get("season") is not None else None
                ),
                "organizationId": obj.get("organizationId"),
                "organization": (
                    SeasonSeriesModelOrganization.from_dict(obj["organization"])
                    if obj.get("organization") is not None
                    else None
                ),
                "conferenceId": obj.get("conferenceId"),
                "conference": (
                    FixtureEntitiesModelConference.from_dict(obj["conference"])
                    if obj.get("conference") is not None
                    else None
                ),
                "divisionId": obj.get("divisionId"),
                "division": (
                    FixtureEntitiesModelDivision.from_dict(obj["division"]) if obj.get("division") is not None else None
                ),
                "nameLocal": obj.get("nameLocal"),
                "abbreviationLocal": obj.get("abbreviationLocal"),
                "nameLatin": obj.get("nameLatin"),
                "abbreviationLatin": obj.get("abbreviationLatin"),
                "status": obj.get("status"),
                "seriesType": obj.get("seriesType"),
                "autoCalculated": obj.get("autoCalculated"),
                "bestOf": obj.get("bestOf"),
                "seriesNumber": obj.get("seriesNumber"),
                "maxFixturesNumber": obj.get("maxFixturesNumber"),
                "winner": obj.get("winner"),
                "seriesOrder": obj.get("seriesOrder"),
                "stageCode": obj.get("stageCode"),
                "stage": (
                    SeasonFixtureStagesPoolsListModelStage.from_dict(obj["stage"])
                    if obj.get("stage") is not None
                    else None
                ),
                "poolCode": obj.get("poolCode"),
                "pool": (
                    SeasonFixtureStagesPoolsListModelPool.from_dict(obj["pool"])
                    if obj.get("pool") is not None
                    else None
                ),
                "startDate": obj.get("startDate"),
                "endDate": obj.get("endDate"),
                "externalId": obj.get("externalId"),
                "updated": obj.get("updated"),
                "added": obj.get("added"),
                "competitors": (
                    [SeasonSeriesCompetitor.from_dict(_item) for _item in obj["competitors"]]
                    if obj.get("competitors") is not None
                    else None
                ),
            }
        )
        return _obj
