# coding: utf-8

"""
DataCore API  - Sport

For more details, see openapi/init.py

The version of the OpenAPI document: v1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing_extensions import Annotated, Self

from atriumsports.datacore.openapi.models.fixture_progressions_model_fixture import FixtureProgressionsModelFixture
from atriumsports.datacore.openapi.models.video_subscriptions_model_organization import (
    VideoSubscriptionsModelOrganization,
)


class VideoSubscriptionsModel(BaseModel):
    """
    VideoSubscriptionsModel
    """  # noqa: E501

    subscription_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the video stream subscription", alias="subscriptionId"
    )
    organization_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the organization", alias="organizationId"
    )
    organization: Optional[VideoSubscriptionsModelOrganization] = None
    customer_id: Optional[StrictInt] = Field(
        default=None, description="Customer of the subscription", alias="customerId"
    )
    fixture_id: Optional[StrictStr] = Field(
        default=None, description="The unique identifier of the fixture", alias="fixtureId"
    )
    fixture: Optional[FixtureProgressionsModelFixture] = None
    provider: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(
        default=None, description="The code for the provider of the file"
    )
    locale: Optional[Annotated[str, Field(min_length=5, strict=True, max_length=5)]] = Field(
        default=None, description="The locale of the video"
    )
    source_number: Optional[StrictInt] = Field(
        default=1,
        description="Unique identifier for the video source. This is unique for the provider/fixtureId/locale combination.  Unless the provider is supplying multiple sources per fixture/locale then this is normally 1.",
        alias="sourceNumber",
    )
    feed_type: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None,
        description="Type of video input >- `ADDITIONAL_ANGLE` Additional angle >- `LOW_LATENCY` Low Latency >- `PRIMARY` Primary ",
        alias="feedType",
    )
    output_resolution: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None,
        description="The resolution that you want to receive the video in.  This is only valid if outputFormat is `RTMP`.  If outputFormat is not `RTMP` then the output resolution is the same as the input resolution.  If specified the output resolution cannot be higher than the input resolution. You must have specific permission to chose anything other than 720p or 1080p. >- `1080` 1920 x 1080 >- `1080i50@10M` SRT 1080i50@10M >- `1080p25@10M` SRT 1080p25@10M >- `1080p50@10M` SRT 1080p50@10M >- `1280x720@2000k` 1280x720@2000k >- `1280x720@3000k` 1280x720@3000k >- `1280x720@3000k25fps` 1280x720@3000k25fps >- `1920x1080@4000k` 1920x1080@4000k >- `1920x1080@4000k25fps` 1920x1080@4000k25fps >- `1920x1080@4500k` 1920x1080@4500k >- `1920x1080@5000k30fps` 1920x1080@5000k30fps >- `2000` 2000 >- `288` 512 x 288 >- `640x320@850k` 640x320@850k >- `720` 1280 x 720 >- `DESKTOP_384x216@280k` DESKTOP_384x216@280k >- `DESKTOP_512x288@500k` DESKTOP_512x288@500k >- `DESKTOP_768x432@1000k` DESKTOP_768x432@1000k >- `MOBILE_320x180@102k` MOBILE_320x180@102k >- `MOBILE_320x180@102k_BUFFERED` MOBILE_320x180@102k_BUFFERED >- `MOBILE_320x180@232k` MOBILE_320x180@232k >- `MOBILE_320x180@232k_BUFFERED` MOBILE_320x180@232k_BUFFERED >- `MOBILE_480x270@464k` MOBILE_480x270@464k >- `MOBILE_480x270@464k_BUFFERED` MOBILE_480x270@464k_BUFFERED >- `MOBILE_768x432@1000k` MOBILE_768x432@1000k >- `MOBILE_768x432@1000k_BUFFERED` MOBILE_768x432@1000k_BUFFERED ",
        alias="outputResolution",
    )
    output_format: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None,
        description="The output format >- `HLS` HLS >- `RTMP` RTMP >- `RTMP_PULL` RTMP Pull >- `SRT` SRT ",
        alias="outputFormat",
    )
    stream_name: Optional[Annotated[str, Field(strict=True, max_length=250)]] = Field(
        default=None,
        description="The name/stream key of the RTMP stream. This is an optional part of the RTMP url - not a text description.",
        alias="streamName",
    )
    subscription_name: Optional[Annotated[str, Field(strict=True, max_length=250)]] = Field(
        default=None, description="The name of the subscription", alias="subscriptionName"
    )
    output_url: Optional[Annotated[str, Field(strict=True, max_length=200)]] = Field(
        default=None,
        description="The URL to send the output to. Only valid if outputFormat is 'RTMP' or 'SRT'",
        alias="outputURL",
    )
    audio: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default="BOTH",
        description="Audio >- `AMBIENCE` Only ambience / crowd noise >- `BOTH` Both combined >- `BOTH_SPLIT_LR` Both (Ambience left channel, Commentary right channel) >- `COMMENTARY` Only commentary ",
    )
    content: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(
        default=None,
        description="Content of the stream >- `CLEAN` Output signal is the same as the input signal >- `PROGRAM` Score overlays and other enhancements have been added to the stream ",
    )
    mux_rate: Optional[StrictInt] = Field(
        default=None, description="The muxRate of the stream. Required for SRT outputFormat only.", alias="muxRate"
    )
    updated: Optional[datetime] = Field(default=None, description="Date/time last modified. In UTC")
    added: Optional[datetime] = Field(default=None, description="Date/time added. In UTC")
    __properties: ClassVar[List[str]] = [
        "subscriptionId",
        "organizationId",
        "organization",
        "customerId",
        "fixtureId",
        "fixture",
        "provider",
        "locale",
        "sourceNumber",
        "feedType",
        "outputResolution",
        "outputFormat",
        "streamName",
        "subscriptionName",
        "outputURL",
        "audio",
        "content",
        "muxRate",
        "updated",
        "added",
    ]

    @field_validator("locale")
    def locale_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[a-z]{2,2}-[A-Z]{2,2}$", value):
            raise ValueError(r"must validate the regular expression /^[a-z]{2,2}-[A-Z]{2,2}$/")
        return value

    @field_validator("feed_type")
    def feed_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["PRIMARY", "ADDITIONAL_ANGLE", "LOW_LATENCY"]):
            raise ValueError("must be one of enum values ('PRIMARY', 'ADDITIONAL_ANGLE', 'LOW_LATENCY')")
        return value

    @field_validator("output_resolution")
    def output_resolution_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(
            [
                "288",
                "720",
                "1080",
                "2000",
                "DESKTOP_768x432@1000k",
                "DESKTOP_512x288@500k",
                "DESKTOP_384x216@280k",
                "MOBILE_768x432@1000k",
                "MOBILE_480x270@464k",
                "MOBILE_320x180@232k",
                "MOBILE_320x180@102k",
                "1920x1080@4000k",
                "1280x720@2000k",
                "640x320@850k",
                "1280x720@3000k25fps",
                "1920x1080@4000k25fps",
                "1920x1080@4500k",
                "1280x720@3000k",
                "1920x1080@5000k30fps",
                "MOBILE_768x432@1000k_BUFFERED",
                "MOBILE_480x270@464k_BUFFERED",
                "MOBILE_320x180@232k_BUFFERED",
                "MOBILE_320x180@102k_BUFFERED",
                "1080i50@10M",
                "1080p25@10M",
                "1080p50@10M",
            ]
        ):
            raise ValueError(
                "must be one of enum values ('288', '720', '1080', '2000', 'DESKTOP_768x432@1000k', 'DESKTOP_512x288@500k', 'DESKTOP_384x216@280k', 'MOBILE_768x432@1000k', 'MOBILE_480x270@464k', 'MOBILE_320x180@232k', 'MOBILE_320x180@102k', '1920x1080@4000k', '1280x720@2000k', '640x320@850k', '1280x720@3000k25fps', '1920x1080@4000k25fps', '1920x1080@4500k', '1280x720@3000k', '1920x1080@5000k30fps', 'MOBILE_768x432@1000k_BUFFERED', 'MOBILE_480x270@464k_BUFFERED', 'MOBILE_320x180@232k_BUFFERED', 'MOBILE_320x180@102k_BUFFERED', '1080i50@10M', '1080p25@10M', '1080p50@10M')"
            )
        return value

    @field_validator("output_format")
    def output_format_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["RTMP", "RTMP_PULL", "HLS", "SRT"]):
            raise ValueError("must be one of enum values ('RTMP', 'RTMP_PULL', 'HLS', 'SRT')")
        return value

    @field_validator("stream_name")
    def stream_name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[0-9A-Za-z.:\/&_?=\-;@]*$", value):
            raise ValueError(r"must validate the regular expression /^[0-9A-Za-z.:\/&_?=\-;@]*$/")
        return value

    @field_validator("output_url")
    def output_url_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[0-9A-Za-z.:\/&_?=\-;@]*$", value):
            raise ValueError(r"must validate the regular expression /^[0-9A-Za-z.:\/&_?=\-;@]*$/")
        return value

    @field_validator("audio")
    def audio_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["COMMENTARY", "AMBIENCE", "BOTH", "BOTH_SPLIT_LR"]):
            raise ValueError("must be one of enum values ('COMMENTARY', 'AMBIENCE', 'BOTH', 'BOTH_SPLIT_LR')")
        return value

    @field_validator("content")
    def content_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(["CLEAN", "PROGRAM"]):
            raise ValueError("must be one of enum values ('CLEAN', 'PROGRAM')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VideoSubscriptionsModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set(
            [
                "organization_id",
                "updated",
                "added",
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of organization
        if self.organization:
            _dict["organization"] = self.organization.to_dict()
        # override the default output from pydantic by calling `to_dict()` of fixture
        if self.fixture:
            _dict["fixture"] = self.fixture.to_dict()
        # set to None if customer_id (nullable) is None
        # and model_fields_set contains the field
        if self.customer_id is None and "customer_id" in self.model_fields_set:
            _dict["customerId"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VideoSubscriptionsModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "subscriptionId": obj.get("subscriptionId"),
                "organizationId": obj.get("organizationId"),
                "organization": (
                    VideoSubscriptionsModelOrganization.from_dict(obj["organization"])
                    if obj.get("organization") is not None
                    else None
                ),
                "customerId": obj.get("customerId"),
                "fixtureId": obj.get("fixtureId"),
                "fixture": (
                    FixtureProgressionsModelFixture.from_dict(obj["fixture"])
                    if obj.get("fixture") is not None
                    else None
                ),
                "provider": obj.get("provider"),
                "locale": obj.get("locale"),
                "sourceNumber": obj.get("sourceNumber") if obj.get("sourceNumber") is not None else 1,
                "feedType": obj.get("feedType"),
                "outputResolution": obj.get("outputResolution"),
                "outputFormat": obj.get("outputFormat"),
                "streamName": obj.get("streamName"),
                "subscriptionName": obj.get("subscriptionName"),
                "outputURL": obj.get("outputURL"),
                "audio": obj.get("audio") if obj.get("audio") is not None else "BOTH",
                "content": obj.get("content"),
                "muxRate": obj.get("muxRate"),
                "updated": obj.get("updated"),
                "added": obj.get("added"),
            }
        )
        return _obj
